<template>
  <div class="d-table">
    <d-pending :on="loading">
      <vs-table
        :search="search"
        class="w-full"
        :data="items"
        :pagination="pagination"
        :max-items="maxItems"
      >
        <template slot="header">
          <div style="z-index: 1;">
            <slot name="tableHeader" />
          </div>
          <div
            v-if="counter"
            class="header-records-counter"
          >{{ itemsAmount + ' ' + $t("admin.generalTitles.records") }}</div>
        </template>

        <template v-if="!isMobile" slot="thead">
          <vs-th
            v-for="(header, index) in structure.headers"
            :key="index"
            :style="`min-width: ${header.minWidth || 0}`"
            v-text="header.title"
          />
        </template>

        <template v-if="isMobile" slot-scope="{ data }">
          <vs-tr v-for="(tr, indexTr) in data" :key="indexTr" class="w-full">
            <vs-td class="w-full">
              <vs-collapse type="margin">
                <vs-collapse-item
                  :style="data[indexTr][highlightParameter] === true ? `border-top: 7px solid ${highlightColorMobile === '' ? highlightColor : highlightColorMobile}` : ''"
                >
                  <!-- MAIN HEADER -->
                  <div slot="header" v-html="getHtml(structure.mobileHeader, tr)" />
                  <!-- CONTENT -->
                  <div v-for="(column, index) in structure.columns" :key="index">
                    <b v-text="structure.headers[index].title" />
                    <br />
                    <div class="mb-3">
                      <div v-if="column.html" v-html="getHtml(column.html, tr)" />
                      <span v-else v-text="tr[column.propName]" />
                    </div>
                  </div>
                </vs-collapse-item>
              </vs-collapse>
            </vs-td>
          </vs-tr>
        </template>

        <template v-else slot-scope="{ data }">
          <vs-tr
            v-for="(tr, indexTr) in data"
            :key="indexTr"
            :style="data[indexTr][highlightParameter] === true ? 'background-color: ' + highlightColor : ''"
            class="w-full"
          >
            <vs-td v-for="(column, index) in structure.columns" :key="index">
              <div v-if="column.html" v-html="getHtml(column.html, tr)" />
              <span v-else v-text="tr[column.propName]" />
            </vs-td>
          </vs-tr>
        </template>
      </vs-table>
    </d-pending>
    <vs-pagination
      v-if="serverPagination"
      :value="currentPage"
      :total="pagesAmount"
      goto
      class="mt-6"
      @change="handleChangePage"
    />
  </div>
</template>

<script>
import { DPending } from "@/components/d-elements";

export default {
  components: {
    DPending
  },

  props: {
    items: {
      required: true,
      type: Array
    },
    maxItems: {
      // max items per page
      required: false,
      type: Number,
      default: 0
    },
    search: {
      // for client side search
      required: false,
      type: Boolean,
      default: false
    },
    pagination: {
      // for client side pagination
      required: false,
      type: Boolean,
      default: false
    },
    serverPagination: {
      required: false,
      type: Boolean,
      default: false
    },
    currentPage: {
      // need for manual switch to page (e.g. when you use link parameter "page")
      required: false,
      type: Number,
      default: 1
    },
    itemsAmount: {
      // for counter and server side pagination
      required: false,
      type: Number,
      default: 0
    },
    notAdaptive: {
      // if true, the desktop version will be shown on all devices
      required: false,
      type: Boolean,
      default: false
    },
    highlightParameter: {
      // name of item parameter. If that parameter is true, the row will be hightlighted in red
      required: false,
      type: String,
      default: ""
    },
    hideHeader: {
      // when we don't need header we can remove empty block before table
      required: false,
      type: Boolean,
      default: false
    },
    highlightColor: {
      required: false,
      type: String,
      default: "#f93030"
    },
    highlightColorMobile: {
      required: false,
      type: String,
      default: ""
    },
    counter: {
      // shows amount of items
      required: false,
      type: Boolean,
      default: false
    },
    loading: {
      // show loading icon
      required: false,
      type: Boolean,
      default: false
    },
    structure: {
      required: false,
      type: Object,
      default: () => ({
        headers: [],
        mobileHeader: "",
        columns: []
      })
    }
  },

  data() {
    return {};
  },

  computed: {
    isMobile() {
      return screen.width < 576;
    },
    pagesAmount() {
      return Math.ceil(this.itemsAmount / this.maxItems);
    }
  },

  methods: {
    getHtml(html, data) {
      if (html) {
        while (html.indexOf("{") !== -1) {
          const start = html.indexOf("{");
          const end = html.indexOf("}");
          const parameter = html.substring(start + 1, end);
          html = html.replace(`{${parameter}}`, data[parameter] || "");
        }
        return html;
      }

      return "";
    },

    handleChangePage(page) {
      this.$emit("pageChanged", page);
    }
  }
};
</script>

<style lang="scss">
.d-table {
  width: 100%;

  .header-records-counter {
    width: 100%;
    text-align: center;
    position: absolute;
    z-index: 0;
    color: #b3b3b3;
  }

  .vs-table--tbody-table
    .tr-values:not(.activeEdit):not(.tr-expandedx):not(.hoverFlat):hover {
    z-index: 100 !important;
    -webkit-transform: translateY(0) !important;
    transform: translateY(0) !important;
  }

  .vs-collapse.margin .vs-collapse-item {
    margin-top: 0;
    margin-bottom: 0;
  }

  .vs-table--content {
    margin-top: 20px;
  }

  .header-table {
    padding-top: 0;
    padding-bottom: 0;
  }

  @media (max-width: 576px) {
    width: 100%;

    .vx-card .vx-card__collapsible-content .vx-card__body {
      padding: 0 !important;
    }

    .vs-table--content {
      margin-top: 0;
    }

    .vx-row {
      margin-left: 0 !important;
      margin-right: 0 !important;
    }

    .adaptive-table .input-search .vs-table--search-input {
      width: 100% !important;
    }

    .adaptive-table .vs-con-table .vs-table--header .vs-table--search {
      margin-left: 0 !important;
      width: 100%;
      min-width: 100%;
      margin-bottom: 12px;
    }

    .adaptive-table .vs-con-table .vs-table--header .vs-table--search > input {
      width: 100%;
      min-width: 100%;
    }

    .adaptive-table .header-table,
    .vs-table--header {
      width: 90% !important;
      margin: auto !important;
    }

    .adaptive-table .vs-con-table table {
      min-width: 0px;
      max-width: 100%;
    }

    .adaptive-table .con-vs-pagination {
      margin: auto !important;
      margin-top: 21px !important;
    }

    .adaptive-table .vs-collapse-item {
      border: 1px solid #e8e8e8;
    }

    .adaptive-table
      .vs-con-table
      .vs-con-tbody
      .vs-table--tbody-table
      .tr-values
      .vs-table--td {
      padding: 0 0 !important;
    }

    .mobile-area-before-table {
      width: 90%;
      margin: auto;
      margin-bottom: 15px;
      padding-top: 23px;
    }

    .adaptive-table .con-content--item {
      font-size: 14px;
    }

    .header-records-counter {
      width: 100%;
      text-align: center;
      position: relative;
      z-index: 0;
      color: #b3b3b3;
      margin-top: 25px;
    }
  }
}
</style>